from ROOT import *
import ROOT
ROOT.gROOT.SetStyle("Plain")
from array import array

import rootStyle

rootStyle.SetRootStyle()

import stop1Linterp, stopCharminterp

doStop1L = True
if doStop1L == True:
    htupla = stop1Linterp.RetrieveTH2() 
    p8715_d22x1y1= stop1Linterp.RetrieveHEPline()
else:
    htupla = stopCharminterp.RetrieveTH2() 
    p8715_d22x1y1= stopCharminterp.RetrieveHEPline()


h2mu = htupla[1]
h2 = htupla[0]
brlist = [0.7**2, 0.5**2, 0.30**2]
hlist = {}
for br in brlist:
    hlist[br] = h2mu.Clone(str(br))
    print br, hlist[br]
    for i in range(hlist[br].GetNbinsX()+1):
        for y in range(hlist[br].GetNbinsY()+1):
            if hlist[br].GetBinContent(hlist[br].GetBin(i,y)) != 0:
                hlist[br].SetBinContent(hlist[br].GetBin(i,y), 1.0/(hlist[br].GetBinContent(hlist[br].GetBin(i,y))/br))
            else:
                hlist[br].SetBinContent(hlist[br].GetBin(i,y), 0.0)



h3mu = h2mu.Clone("test")
for i in range(h3mu.GetNbinsX()+1):
    for y in range(h3mu.GetNbinsY()+1):
        if h3mu.GetBinContent(i,y) != 0:
            h3mu.SetBinContent(h3mu.GetBin(i,y), 1.0/h3mu.GetBinContent(i,y))

c1 = TCanvas()
#h3mu.Smooth(1)


from ROOT import *


gStyle.SetPaintTextFormat(".3f");
#h3mu.Smooth(1)
h3mu.SetContour(1)
h3mu.SetLineColor(kAzure+2)
h3mu.SetFillColor(kAzure+2)
h3mu.SetLineWidth(4)
h3mu.SetContourLevel(0, 1.0 );
h2.Draw("text")

p8715_d22x1y1.Draw("L same")

legend = TLegend(0.14,0.7,0.5,0.95)
legend.SetFillStyle(0)
legend.SetFillColor(0)
legend.SetBorderSize(0)
#legend.SetTextSize(0.055)
legend.AddEntry(p8715_d22x1y1, "ATLAS Contour HepData", "l")

if doStop1L:
    legend.AddEntry(h3mu, "Rescale BR(t#chi^{0}) = 100%", "l")
else:
    legend.AddEntry(h3mu, "Rescale BR(c#chi^{0}) = 100%", "l")

import math

colors= [kOrange+1, kMagenta+1, kGreen+2]
c=0
for h in brlist:
    print h
    hlist[h].SetContour(1)
    hlist[h].SetContourLevel(0, 1.0 );
    hlist[h].SetLineColor(colors[c])
    hlist[h].SetFillColor(colors[c])
    hlist[h].SetLineWidth(4)
    hlist[h].SetLineStyle(1)
    hlist[h].Draw("cont3 same")
    if doStop1L:
        legend.AddEntry(hlist[h], "Rescale BR(t#chi^{0}) = "+str(round(math.sqrt(h)*100,2))+"%", "l")
    else:
        legend.AddEntry(hlist[h], "Rescale BR(c#chi^{0}) = "+str(round(math.sqrt(h)*100,2))+"%", "l")
    c+=1


h3mu.Draw("cont3 same")

h3mu.GetXaxis().SetRangeUser(0,800)
h3mu.GetYaxis().SetRangeUser(0,400)
h3mu.GetXaxis().SetTitle("stop mass")
h3mu.GetXaxis().SetTitle("LSP mass")
h3mu.GetXaxis().SetNdivisions(110)
h3mu.GetYaxis().SetNdivisions(107)


if doStop1L:
    h2.GetXaxis().SetTitle("stop mass [GeV]")
    h2.GetXaxis().SetRangeUser(0.,810)
    h2.GetYaxis().SetRangeUser(0.20,320)
else:
    h2.GetXaxis().SetTitle("scharm mass [GeV]")
    h2.GetXaxis().SetRangeUser(100.,510)
    h2.GetYaxis().SetRangeUser(0.20,320)

h2.GetYaxis().SetTitle("LSP mass [GeV]")
h2.GetXaxis().SetNdivisions(410)
h2.GetYaxis().SetNdivisions(407)

legend.Draw()
if doStop1L:
    c1.SaveAs("stop1LRun1.png")
else:
    c1.SaveAs("scharmRun1.png")
