


def SetRootStyle():

    import ROOT
    
    # this is already implemented in the options below
    #ROOT.gROOT.LoadMacro("AtlasStyle.C")
    #ROOT.gROOT.SetAtlasStyle()

    #ROOT.gROOT.SetStyle("ATLAS");
    #ROOT.gROOT.ForceStyle();
    
    ROOT.gStyle.SetOptStat(0);
    ROOT.gStyle.SetOptTitle(0);


    ROOT.gROOT.SetBatch(True)

    icol=0
    ROOT.gStyle.SetFrameBorderMode(icol)
    ROOT.gStyle.SetFrameFillColor(icol)
    ROOT.gStyle.SetCanvasBorderMode(icol)
    ROOT.gStyle.SetCanvasColor(icol)
    ROOT.gStyle.SetPadBorderMode(icol)
    ROOT.gStyle.SetPadColor(icol)
    ROOT.gStyle.SetStatColor(icol)

    ROOT.gStyle.SetPaperSize(20,26)

    ROOT.gStyle.SetPadTopMargin(0.03)
    ROOT.gStyle.SetPadRightMargin(0.03)
    ROOT.gStyle.SetPadBottomMargin(0.12)
    ROOT.gStyle.SetPadLeftMargin(0.12)

    ROOT.gStyle.SetTitleXOffset(1.05)
    ROOT.gStyle.SetTitleYOffset(1.05)
    font=42
    tsize=0.045
    ROOT.gStyle.SetTextFont(font)
    ROOT.gStyle.SetTextSize(tsize)
    ROOT.gStyle.SetLabelFont(font,"x")
    ROOT.gStyle.SetTitleFont(font,"x")
    ROOT.gStyle.SetLabelFont(font,"y")
    ROOT.gStyle.SetTitleFont(font,"y")
    ROOT.gStyle.SetLabelFont(font,"z")
    ROOT.gStyle.SetTitleFont(font,"z")
    ROOT.gStyle.SetLabelSize(tsize,"x")
    ROOT.gStyle.SetTitleSize(tsize,"x")
    ROOT.gStyle.SetLabelSize(tsize,"y")
    ROOT.gStyle.SetTitleSize(tsize,"y")
    ROOT.gStyle.SetLabelSize(tsize,"z")
    ROOT.gStyle.SetTitleSize(tsize,"z")
    ROOT.gStyle.SetMarkerStyle(20)
    ROOT.gStyle.SetMarkerSize(1.2)
    ROOT.gStyle.SetHistLineWidth(2)
    ROOT.gStyle.SetLineStyleString(2,"[12 12]")
    ROOT.gStyle.SetEndErrorSize(0.)
    
    ROOT.gStyle.SetOptFit(0)
    ROOT.gStyle.SetPadTickX(1)
    ROOT.gStyle.SetPadTickY(1)

    from array import array
#     fPaletteColor = array('i', [51, 52, 53, 54, 55, 56, 57, 58, 59,
#                                 60, 61, 62, 63, 64, 65, 66, 67, 68, 69,
#                                 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
#                                 80, 81, 82, 83, 84, 85, 86, 87, 88, 89,
#                                 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100])
#     #ROOT.gStyle.SetPalette(8);
#     ROOT.gStyle.SetPalette(50, fPaletteColor);

    set_palette()

def set_palette(name='palette', ncontours=999):
    """Set a color palette from a given RGB list
    stops, red, green and blue should all be lists of the same length
    see set_decent_colors for an example"""
    from array import array
    import ROOT
    if name == "gray" or name == "grayscale":
        stops = [0.00, 0.34, 0.61, 0.84, 1.00]
        red   = [1.00, 0.84, 0.61, 0.34, 0.00]
        green = [1.00, 0.84, 0.61, 0.34, 0.00]
        blue  = [1.00, 0.84, 0.61, 0.34, 0.00]
    #elif name == "whatever":

        # (define more palettes)
    else:
        stops = [0.5, 0.8,1]
        red   = [1,0.2,0.2,0]
        green = [1,0.5,0.2,0]
        blue  = [1,1  ,1, 0]


#        green   = [ 0 ,0.87,0.5, 1.00,1      ]
#        red     = [ 0 ,0,   0,    0.00,1      ]
#        blue    = [0.3,0,    1,    1   , 1.00] 

#         # default palette, looks cool
#        stops = [0.00, 0.34, 0.61, 0.84, 1.00]
#        red   = [0.00, 0.00, 0.87, 1.00, 0.51]
#        green = [0.00, 0.81, 1.00, 0.20, 0.00]
#        blue  = [0.51, 1.00, 0.12, 0.00, 0.00]

    s = array('d', stops)
    r = array('d', red)
    g = array('d', green)
    b = array('d', blue)

    npoints = len(s)
    ROOT.TColor.CreateGradientColorTable(npoints, s, r, g, b, ncontours)
    ROOT.gStyle.SetNumberContours(ncontours)

